<?php
/**
 * KundeReadKundeRead
 *
 * PHP version 7.4
 *
 * @category Class
 * @package  SLIS\Adapter\Hub
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * slis hub
 *
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: 0.7.4
 * Contact: dev@slis.io
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.1.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Hub\Model;

use \ArrayAccess;
use \SLIS\Adapter\Hub\ObjectSerializer;

/**
 * KundeReadKundeRead Class Doc Comment
 *
 * @category Class
 * @package  SLIS\Adapter\Hub
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<string, mixed>
 */
class KundeReadKundeRead implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'Kunde-read_kunde.read';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'name' => 'string',
        'nummer' => 'string',
        'kennzeichen' => 'string',
        'bsnr' => 'int',
        'institutionskennzeichen' => 'int',
        'adresse' => '\SLIS\Adapter\Hub\Model\AdresseReadKundeRead',
        'rechungsadresse' => '\SLIS\Adapter\Hub\Model\KundeReadKundeReadRechungsadresse',
        'standorte' => '\SLIS\Adapter\Hub\Model\StandortReadKundeRead[]',
        'benutzer' => '\SLIS\Adapter\Hub\Model\BenutzerReadKundeRead[]',
        'kategorien' => 'string[]',
        'bestellungen' => '\SLIS\Adapter\Hub\Model\BestellungReadKundeRead[]',
        'uuid' => 'string',
        'created' => '\DateTime',
        'updated' => '\DateTime'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'name' => null,
        'nummer' => null,
        'kennzeichen' => null,
        'bsnr' => null,
        'institutionskennzeichen' => null,
        'adresse' => null,
        'rechungsadresse' => null,
        'standorte' => null,
        'benutzer' => null,
        'kategorien' => 'iri-reference',
        'bestellungen' => null,
        'uuid' => null,
        'created' => 'date-time',
        'updated' => 'date-time'
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static array $openAPINullables = [
        'name' => false,
		'nummer' => true,
		'kennzeichen' => true,
		'bsnr' => true,
		'institutionskennzeichen' => true,
		'adresse' => false,
		'rechungsadresse' => true,
		'standorte' => false,
		'benutzer' => false,
		'kategorien' => false,
		'bestellungen' => false,
		'uuid' => false,
		'created' => true,
		'updated' => true
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected array $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of nullable properties
     *
     * @return array
     */
    protected static function openAPINullables(): array
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return boolean[]
     */
    private function getOpenAPINullablesSetToNull(): array
    {
        return $this->openAPINullablesSetToNull;
    }

    /**
     * Checks if a property is nullable
     *
     * @param string $property
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        return self::openAPINullables()[$property] ?? false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @param string $property
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        return in_array($property, $this->getOpenAPINullablesSetToNull(), true);
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'name' => 'name',
        'nummer' => 'nummer',
        'kennzeichen' => 'kennzeichen',
        'bsnr' => 'bsnr',
        'institutionskennzeichen' => 'institutionskennzeichen',
        'adresse' => 'adresse',
        'rechungsadresse' => 'rechungsadresse',
        'standorte' => 'standorte',
        'benutzer' => 'benutzer',
        'kategorien' => 'kategorien',
        'bestellungen' => 'bestellungen',
        'uuid' => 'uuid',
        'created' => 'created',
        'updated' => 'updated'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'name' => 'setName',
        'nummer' => 'setNummer',
        'kennzeichen' => 'setKennzeichen',
        'bsnr' => 'setBsnr',
        'institutionskennzeichen' => 'setInstitutionskennzeichen',
        'adresse' => 'setAdresse',
        'rechungsadresse' => 'setRechungsadresse',
        'standorte' => 'setStandorte',
        'benutzer' => 'setBenutzer',
        'kategorien' => 'setKategorien',
        'bestellungen' => 'setBestellungen',
        'uuid' => 'setUuid',
        'created' => 'setCreated',
        'updated' => 'setUpdated'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'name' => 'getName',
        'nummer' => 'getNummer',
        'kennzeichen' => 'getKennzeichen',
        'bsnr' => 'getBsnr',
        'institutionskennzeichen' => 'getInstitutionskennzeichen',
        'adresse' => 'getAdresse',
        'rechungsadresse' => 'getRechungsadresse',
        'standorte' => 'getStandorte',
        'benutzer' => 'getBenutzer',
        'kategorien' => 'getKategorien',
        'bestellungen' => 'getBestellungen',
        'uuid' => 'getUuid',
        'created' => 'getCreated',
        'updated' => 'getUpdated'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }


    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('name', $data ?? [], null);
        $this->setIfExists('nummer', $data ?? [], null);
        $this->setIfExists('kennzeichen', $data ?? [], null);
        $this->setIfExists('bsnr', $data ?? [], null);
        $this->setIfExists('institutionskennzeichen', $data ?? [], null);
        $this->setIfExists('adresse', $data ?? [], null);
        $this->setIfExists('rechungsadresse', $data ?? [], null);
        $this->setIfExists('standorte', $data ?? [], null);
        $this->setIfExists('benutzer', $data ?? [], null);
        $this->setIfExists('kategorien', $data ?? [], null);
        $this->setIfExists('bestellungen', $data ?? [], null);
        $this->setIfExists('uuid', $data ?? [], null);
        $this->setIfExists('created', $data ?? [], null);
        $this->setIfExists('updated', $data ?? [], null);
    }

    /**
    * Sets $this->container[$variableName] to the given data or to the given default Value; if $variableName
    * is nullable and its value is set to null in the $fields array, then mark it as "set to null" in the
    * $this->openAPINullablesSetToNull array
    *
    * @param string $variableName
    * @param array  $fields
    * @param mixed  $defaultValue
    */
    private function setIfExists(string $variableName, array $fields, $defaultValue): void
    {
        if (self::isNullable($variableName) && array_key_exists($variableName, $fields) && is_null($fields[$variableName])) {
            $this->openAPINullablesSetToNull[] = $variableName;
        }

        $this->container[$variableName] = $fields[$variableName] ?? $defaultValue;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['name'] === null) {
            $invalidProperties[] = "'name' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets name
     *
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string $name name
     *
     * @return self
     */
    public function setName($name)
    {

        if (is_null($name)) {
            throw new \InvalidArgumentException('non-nullable name cannot be null');
        }

        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets nummer
     *
     * @return string|null
     */
    public function getNummer()
    {
        return $this->container['nummer'];
    }

    /**
     * Sets nummer
     *
     * @param string|null $nummer nummer
     *
     * @return self
     */
    public function setNummer($nummer)
    {

        if (is_null($nummer)) {
            array_push($this->openAPINullablesSetToNull, 'nummer');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('nummer', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['nummer'] = $nummer;

        return $this;
    }

    /**
     * Gets kennzeichen
     *
     * @return string|null
     */
    public function getKennzeichen()
    {
        return $this->container['kennzeichen'];
    }

    /**
     * Sets kennzeichen
     *
     * @param string|null $kennzeichen kennzeichen
     *
     * @return self
     */
    public function setKennzeichen($kennzeichen)
    {

        if (is_null($kennzeichen)) {
            array_push($this->openAPINullablesSetToNull, 'kennzeichen');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('kennzeichen', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['kennzeichen'] = $kennzeichen;

        return $this;
    }

    /**
     * Gets bsnr
     *
     * @return int|null
     */
    public function getBsnr()
    {
        return $this->container['bsnr'];
    }

    /**
     * Sets bsnr
     *
     * @param int|null $bsnr bsnr
     *
     * @return self
     */
    public function setBsnr($bsnr)
    {

        if (is_null($bsnr)) {
            array_push($this->openAPINullablesSetToNull, 'bsnr');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('bsnr', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['bsnr'] = $bsnr;

        return $this;
    }

    /**
     * Gets institutionskennzeichen
     *
     * @return int|null
     */
    public function getInstitutionskennzeichen()
    {
        return $this->container['institutionskennzeichen'];
    }

    /**
     * Sets institutionskennzeichen
     *
     * @param int|null $institutionskennzeichen institutionskennzeichen
     *
     * @return self
     */
    public function setInstitutionskennzeichen($institutionskennzeichen)
    {

        if (is_null($institutionskennzeichen)) {
            array_push($this->openAPINullablesSetToNull, 'institutionskennzeichen');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('institutionskennzeichen', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['institutionskennzeichen'] = $institutionskennzeichen;

        return $this;
    }

    /**
     * Gets adresse
     *
     * @return \SLIS\Adapter\Hub\Model\AdresseReadKundeRead|null
     */
    public function getAdresse()
    {
        return $this->container['adresse'];
    }

    /**
     * Sets adresse
     *
     * @param \SLIS\Adapter\Hub\Model\AdresseReadKundeRead|null $adresse adresse
     *
     * @return self
     */
    public function setAdresse($adresse)
    {

        if (is_null($adresse)) {
            throw new \InvalidArgumentException('non-nullable adresse cannot be null');
        }

        $this->container['adresse'] = $adresse;

        return $this;
    }

    /**
     * Gets rechungsadresse
     *
     * @return \SLIS\Adapter\Hub\Model\KundeReadKundeReadRechungsadresse|null
     */
    public function getRechungsadresse()
    {
        return $this->container['rechungsadresse'];
    }

    /**
     * Sets rechungsadresse
     *
     * @param \SLIS\Adapter\Hub\Model\KundeReadKundeReadRechungsadresse|null $rechungsadresse rechungsadresse
     *
     * @return self
     */
    public function setRechungsadresse($rechungsadresse)
    {

        if (is_null($rechungsadresse)) {
            array_push($this->openAPINullablesSetToNull, 'rechungsadresse');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('rechungsadresse', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['rechungsadresse'] = $rechungsadresse;

        return $this;
    }

    /**
     * Gets standorte
     *
     * @return \SLIS\Adapter\Hub\Model\StandortReadKundeRead[]|null
     */
    public function getStandorte()
    {
        return $this->container['standorte'];
    }

    /**
     * Sets standorte
     *
     * @param \SLIS\Adapter\Hub\Model\StandortReadKundeRead[]|null $standorte standorte
     *
     * @return self
     */
    public function setStandorte($standorte)
    {

        if (is_null($standorte)) {
            throw new \InvalidArgumentException('non-nullable standorte cannot be null');
        }

        $this->container['standorte'] = $standorte;

        return $this;
    }

    /**
     * Gets benutzer
     *
     * @return \SLIS\Adapter\Hub\Model\BenutzerReadKundeRead[]|null
     */
    public function getBenutzer()
    {
        return $this->container['benutzer'];
    }

    /**
     * Sets benutzer
     *
     * @param \SLIS\Adapter\Hub\Model\BenutzerReadKundeRead[]|null $benutzer benutzer
     *
     * @return self
     */
    public function setBenutzer($benutzer)
    {

        if (is_null($benutzer)) {
            throw new \InvalidArgumentException('non-nullable benutzer cannot be null');
        }

        $this->container['benutzer'] = $benutzer;

        return $this;
    }

    /**
     * Gets kategorien
     *
     * @return string[]|null
     */
    public function getKategorien()
    {
        return $this->container['kategorien'];
    }

    /**
     * Sets kategorien
     *
     * @param string[]|null $kategorien kategorien
     *
     * @return self
     */
    public function setKategorien($kategorien)
    {

        if (is_null($kategorien)) {
            throw new \InvalidArgumentException('non-nullable kategorien cannot be null');
        }

        $this->container['kategorien'] = $kategorien;

        return $this;
    }

    /**
     * Gets bestellungen
     *
     * @return \SLIS\Adapter\Hub\Model\BestellungReadKundeRead[]|null
     */
    public function getBestellungen()
    {
        return $this->container['bestellungen'];
    }

    /**
     * Sets bestellungen
     *
     * @param \SLIS\Adapter\Hub\Model\BestellungReadKundeRead[]|null $bestellungen bestellungen
     *
     * @return self
     */
    public function setBestellungen($bestellungen)
    {

        if (is_null($bestellungen)) {
            throw new \InvalidArgumentException('non-nullable bestellungen cannot be null');
        }

        $this->container['bestellungen'] = $bestellungen;

        return $this;
    }

    /**
     * Gets uuid
     *
     * @return string|null
     */
    public function getUuid()
    {
        return $this->container['uuid'];
    }

    /**
     * Sets uuid
     *
     * @param string|null $uuid uuid
     *
     * @return self
     */
    public function setUuid($uuid)
    {

        if (is_null($uuid)) {
            throw new \InvalidArgumentException('non-nullable uuid cannot be null');
        }

        $this->container['uuid'] = $uuid;

        return $this;
    }

    /**
     * Gets created
     *
     * @return \DateTime|null
     */
    public function getCreated()
    {
        return $this->container['created'];
    }

    /**
     * Sets created
     *
     * @param \DateTime|null $created created
     *
     * @return self
     */
    public function setCreated($created)
    {

        if (is_null($created)) {
            array_push($this->openAPINullablesSetToNull, 'created');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('created', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['created'] = $created;

        return $this;
    }

    /**
     * Gets updated
     *
     * @return \DateTime|null
     */
    public function getUpdated()
    {
        return $this->container['updated'];
    }

    /**
     * Sets updated
     *
     * @param \DateTime|null $updated updated
     *
     * @return self
     */
    public function setUpdated($updated)
    {

        if (is_null($updated)) {
            array_push($this->openAPINullablesSetToNull, 'updated');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('updated', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['updated'] = $updated;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


